<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRPMRangeItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfRPMRangeItem extends AbstractStructArrayBase
{
    /**
     * The RPMRangeItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RPMRangeItem[]
     */
    public $RPMRangeItem;
    /**
     * Constructor method for ArrayOfRPMRangeItem
     * @uses ArrayOfRPMRangeItem::setRPMRangeItem()
     * @param \StructType\RPMRangeItem[] $rPMRangeItem
     */
    public function __construct(array $rPMRangeItem = array())
    {
        $this
            ->setRPMRangeItem($rPMRangeItem);
    }
    /**
     * Get RPMRangeItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RPMRangeItem[]|null
     */
    public function getRPMRangeItem()
    {
        return isset($this->RPMRangeItem) ? $this->RPMRangeItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRPMRangeItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRPMRangeItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRPMRangeItemForArrayConstraintsFromSetRPMRangeItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRPMRangeItemRPMRangeItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfRPMRangeItemRPMRangeItemItem instanceof \StructType\RPMRangeItem) {
                $invalidValues[] = is_object($arrayOfRPMRangeItemRPMRangeItemItem) ? get_class($arrayOfRPMRangeItemRPMRangeItemItem) : sprintf('%s(%s)', gettype($arrayOfRPMRangeItemRPMRangeItemItem), var_export($arrayOfRPMRangeItemRPMRangeItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RPMRangeItem property can only contain items of type \StructType\RPMRangeItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RPMRangeItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RPMRangeItem[] $rPMRangeItem
     * @return \ArrayType\ArrayOfRPMRangeItem
     */
    public function setRPMRangeItem(array $rPMRangeItem = array())
    {
        // validation for constraint: array
        if ('' !== ($rPMRangeItemArrayErrorMessage = self::validateRPMRangeItemForArrayConstraintsFromSetRPMRangeItem($rPMRangeItem))) {
            throw new \InvalidArgumentException($rPMRangeItemArrayErrorMessage, __LINE__);
        }
        if (is_null($rPMRangeItem) || (is_array($rPMRangeItem) && empty($rPMRangeItem))) {
            unset($this->RPMRangeItem);
        } else {
            $this->RPMRangeItem = $rPMRangeItem;
        }
        return $this;
    }
    /**
     * Add item to RPMRangeItem value
     * @throws \InvalidArgumentException
     * @param \StructType\RPMRangeItem $item
     * @return \ArrayType\ArrayOfRPMRangeItem
     */
    public function addToRPMRangeItem(\StructType\RPMRangeItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RPMRangeItem) {
            throw new \InvalidArgumentException(sprintf('The RPMRangeItem property can only contain items of type \StructType\RPMRangeItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RPMRangeItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RPMRangeItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RPMRangeItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RPMRangeItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RPMRangeItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RPMRangeItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RPMRangeItem
     */
    public function getAttributeName()
    {
        return 'RPMRangeItem';
    }
}
